#include "Vista.h"
	SUBROUTINE SNPHOT

	INCLUDE 'vistadisk/source/include/vistalink.inc'
	INCLUDE 'vistadisk/source/include/imagelink.inc'
	LOGICAL KEYCHECK
        PARAMETER (NMAX=200)
	INTEGER IMSN(NMAX), PSFSN(NMAX)
#ifdef __64BITADDRESS
        INTEGER*8 LOCFRAME(NMAX), LOCPSF(NMAX)
#else
        INTEGER LOCFRAME(NMAX), LOCPSF(NMAX)
#endif
	REAL*8 SNCRVAL1(NMAX), SNCRVAL2(NMAX), CD1_1(NMAX), CD1_2(NMAX)
	REAL*8 CD2_1(NMAX), CD2_2(NMAX), JD(NMAX), BACK(NMAX), PSFDX(NMAX)
	REAL*8 GAIN(NMAX), RN(NMAX), LOWBAD(NMAX), HIGHBAD(NMAX)
        REAL TMP(NMAX)
	INTEGER SNCRPIX1(NMAX), SNCRPIX2(NMAX), SNCNPIX1(NMAX), SNCNPIX2(NMAX)
	INTEGER TELE(NMAX), FILT(NMAX), SNNX(NMAX), SNNY(NMAX), PSFN(NMAX)
        INTEGER BACKGRID, SUB
	CHARACTER*80 TWORD, STARFILE, SNFILE, PARFILE
	CHARACTER PARM*8

	CALL KEYINIT
	CALL KEYDEF('IM=')
	CALL KEYDEF('PSF=')
	CALL KEYDEF('STARS=')
	CALL KEYDEF('SN=')
	CALL KEYDEF('PAR=')
	CALL KEYDEF('NITER=')
	CALL KEYDEF('NGAL=')
	CALL KEYDEF('NVAR=')
	CALL KEYDEF('NSTARS=')
	CALL KEYDEF('DMAX=')
	CALL KEYDEF('BACKGRID=')
	CALL KEYDEF('SUB=')

        STARFILE(1:1) = CHAR(0)
        SNFILE(1:1) = CHAR(0)
        PARFILE(1:1) = CHAR(0)
        NIM = 0
        NSTARS = 100
        NVAR = 1 
        NGAL = 1 
        DMAX = 100.
        BACKGRID = 10
        SUB = 0
	DO 5501 I=1,NCON
          TWORD = WORD(I)
          L = UPPER(TWORD)
          IF (TWORD(1:3) .EQ. 'IM=') THEN
            CALL ASSIGNV(WORD(I),NMAX,TMP,NIM,PARM)
            IF (XERR) RETURN
	    DO J=1,NIM
              IMSN(J) = NINT(TMP(J))
            END DO
          ELSE IF (TWORD(1:4) .EQ. 'PSF=') THEN
            CALL ASSIGNV(WORD(I),NMAX,TMP,NPSF,PARM)
	    DO J=1,NPSF
              PSFSN(J) = NINT(TMP(J))
            END DO
            IF (XERR) RETURN
          ELSE IF (TWORD(1:6) .EQ. 'STARS=') THEN
            STARFILE = WORD(I)(7:)
            L = INDEX(STARFILE, ' ')
            STARFILE(L:L) = CHAR(0)
          ELSE IF (TWORD(1:3) .EQ. 'SN=') THEN
            SNFILE = WORD(I)(4:)
            L = INDEX(SNFILE, ' ')
            SNFILE(L:L) = CHAR(0)
          ELSE IF (TWORD(1:4) .EQ. 'PAR=') THEN
            PARFILE = WORD(I)(5:)
            L = INDEX(PARFILE, ' ')
            PARFILE(L:L) = CHAR(0)
          ELSE IF (TWORD(1:6) .EQ. 'NITER=') THEN
            CALL ASSIGN(WORD(I),TMP,PARM)
            NITER = NINT(TMP(1))
          ELSE IF (TWORD(1:5) .EQ. 'NGAL=') THEN
            CALL ASSIGN(WORD(I),TMP,PARM)
            NGAL = NINT(TMP(1))
          ELSE IF (TWORD(1:5) .EQ. 'NVAR=') THEN
            CALL ASSIGN(WORD(I),TMP,PARM)
            NVAR = NINT(TMP(1))
          ELSE IF (TWORD(1:7) .EQ. 'NSTARS=') THEN
            CALL ASSIGN(WORD(I),TMP,PARM)
            NSTARS = NINT(TMP(1))
          ELSE IF (TWORD(1:9) .EQ. 'BACKGRID=') THEN
            CALL ASSIGN(WORD(I),TMP,PARM)
            BACKGRID = NINT(TMP(1))
          ELSE IF (TWORD(1:4) .EQ. 'SUB=') THEN
            CALL ASSIGN(WORD(I),TMP,PARM)
            SUB = NINT(TMP(1))
          ELSE IF (TWORD(1:5) .EQ. 'DMAX=') THEN
            CALL ASSIGN(WORD(I),DMAX,PARM)
          END IF
5501	CONTINUE

	IF (.NOT. KEYCHECK()) THEN
          XERR = .TRUE.
          RETURN
        END IF

	IF (NIM .GT. NMAX) THEN
          PRINT *, 'Too many images specified on command line', NIM, NMAX
	  XERR = .TRUE.
	  RETURN
	END IF

        IF (NIM .NE. NPSF) THEN
          PRINT *, 'Number of PSFs dont match number of frames'
          XERR = .TRUE.
          RETURN
        END IF

	DO I=1,NIM
	  LOCFRAME(I) = IMLOC(IMSN(I))
          CALL CCINHEAD('NAXIS1',HEADBUF(1,IMSN(I)),SNNX(I))
          CALL CCINHEAD('NAXIS2',HEADBUF(1,IMSN(I)),SNNY(I))
          CALL CCFHEAD('CRVAL1',HEADBUF(1,IMSN(I)),SNCRVAL1(I))
          CALL CCFHEAD('CRVAL2',HEADBUF(1,IMSN(I)),SNCRVAL2(I))
          CALL CCFHEAD('CD1_1',HEADBUF(1,IMSN(I)),CD1_1(I))
          CALL CCFHEAD('CD1_2',HEADBUF(1,IMSN(I)),CD1_2(I))
          CALL CCFHEAD('CD2_1',HEADBUF(1,IMSN(I)),CD2_1(I))
          CALL CCFHEAD('CD2_2',HEADBUF(1,IMSN(I)),CD2_2(I))
          CALL CCINHEAD('CRPIX1',HEADBUF(1,IMSN(I)),SNCRPIX1(I))
          CALL CCINHEAD('CRPIX2',HEADBUF(1,IMSN(I)),SNCRPIX2(I))
          CALL CCINHEAD('CNPIX1',HEADBUF(1,IMSN(I)),SNCNPIX1(I))
          CALL CCINHEAD('CNPIX2',HEADBUF(1,IMSN(I)),SNCNPIX2(I))
          CALL CCINHEAD('TELE',HEADBUF(1,IMSN(I)),TELE(I))
          CALL CCINHEAD('FILT',HEADBUF(1,IMSN(I)),FILT(I))
          CALL CCFHEAD('BACK',HEADBUF(1,IMSN(I)),BACK(I))
          CALL CCFHEAD('MJD',HEADBUF(1,IMSN(I)),JD(I))
          CALL CCFHEAD('GAIN',HEADBUF(1,IMSN(I)),GAIN(I))
          CALL CCFHEAD('RN',HEADBUF(1,IMSN(I)),RN(I))
          CALL CCFHEAD('LOWBAD',HEADBUF(1,IMSN(I)),LOWBAD(I))
          CALL CCFHEAD('HIGHBAD',HEADBUF(1,IMSN(I)),HIGHBAD(I))
	  LOCPSF(I) = IMLOC(PSFSN(I))
          CALL CCINHEAD('NAXIS1',HEADBUF(1,PSFSN(I)),PSFN(I))
          CALL CCFHEAD('CDELT1',HEADBUF(1,PSFSN(I)),PSFDX(I))
        END DO

        CALL DOSNPHOT(NIM, LOCFRAME, SNNX, SNNY,
     &         SNCRVAL1, SNCRVAL2, CD1_1, CD1_2, CD2_1, CD2_2,
     &         SNCRPIX1, SNCRPIX2, SNCNPIX1, SNCNPIX2, TELE, FILT, BACK, JD,
     &         GAIN, RN, LOWBAD, HIGHBAD,
     &         LOCPSF, PSFN, PSFDX, NITER, NVAR, NGAL, NSTARS, DMAX, BACKGRID,
     &         SUB, STARFILE, SNFILE, PARFILE)

	RETURN
	END	
